pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-bDKkI6/polyorb-2.11~20140418/idls/CORBA_IDL/orb.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with CORBA;
pragma Elaborate_All (CORBA);
with CORBA.Repository_Root.ArrayDef.Impl;
with PolyORB.Any;
with CORBA.ServerRequest;
with CORBA.NVList;
with CORBA.Repository_Root.IDLType;
with CORBA.Object.Helper;
with CORBA.Object;
with CORBA.Repository_Root.IDLType.Helper;
with CORBA.Repository_Root.Helper;
with PolyORB.CORBA_P.IR_Hooks;
with PolyORB.CORBA_P.Domain_Management;
with CORBA_Repository_Root_ArrayDef_Hash;
with PolyORB.Std;
with PortableServer;
with CORBA.ORB;
with PolyORB.CORBA_P.Exceptions;
with PolyORB.Qos.Exception_Informations;
with PolyORB.Utils.Strings;
with PolyORB.Utils.Strings.Lists;
with PolyORB.Initialization;

package body CORBA.Repository_Root.ArrayDef.Skel is

   set_length_Arg_Name_To_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("To");

   set_element_type_def_Arg_Name_To_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("To");

   N_Operations : constant PolyORB.Std.Natural :=
     13;

   type String_Ptr is
     access PolyORB.Std.String;

   Invoke_Db : array (0 .. (N_Operations
      - 1)) of String_Ptr :=
     (others => null);

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String);

   ------------------------
   -- Register_Procedure --
   ------------------------

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String)
   is
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;
   begin
      Index_ :=
        CORBA_Repository_Root_ArrayDef_Hash.Hash
           (Operation_Name);
      if (Invoke_Db
        (Index_)
         /= null)
      then
         raise Program_Error;
      end if;
      Invoke_Name_Access :=
        new PolyORB.Std.String'
           (Operation_Name);
      Invoke_Db
        (Index_) :=
        Invoke_Name_Access;
   end Register_Procedure;

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr);

   ------------
   -- Invoke --
   ------------

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr)
   is
      Operation_ : constant PolyORB.Std.String :=
        CORBA.To_Standard_String
           (CORBA.ServerRequest.Operation
              (Request.all));
      Argument_List_ : CORBA.NVList.Ref;
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;

      procedure Invoke_Uget_length;

      ------------------------
      -- Invoke_Uget_length --
      ------------------------

      procedure Invoke_Uget_length is
         Result_ : CORBA.Unsigned_Long;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (Result_'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.TC_Unsigned_Long,
               Arg_CC_Result__'Unchecked_Access);
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CORBA.Repository_Root.ArrayDef.Impl.get_length
              (CORBA.Repository_Root.ArrayDef.Impl.Object'Class
                 (Self.all)'Access);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_Uget_length;

      procedure Invoke_Uset_length;

      ------------------------
      -- Invoke_Uset_length --
      ------------------------

      procedure Invoke_Uset_length is
         Argument_To_ : CORBA.Unsigned_Long;
         pragma Warnings (Off, Argument_To_);
         pragma Suppress (Validity_Check, Argument_To_);
         Arg_CC_To_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (Argument_To_'Unrestricted_Access);
         Arg_Any_To_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.TC_Unsigned_Long,
               Arg_CC_To_'Unchecked_Access);
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            set_length_Arg_Name_To_,
            Arg_Any_To_,
            CORBA.ARG_IN);
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         CORBA.Repository_Root.ArrayDef.Impl.set_length
           (CORBA.Repository_Root.ArrayDef.Impl.Object'Class
              (Self.all)'Access,
            Argument_To_);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_Uset_length;

      procedure Invoke_Uget_element_type;

      ------------------------------
      -- Invoke_Uget_element_type --
      ------------------------------

      procedure Invoke_Uget_element_type is
         Result_ : CORBA.TypeCode.Object;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (Result_'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.TC_TypeCode,
               Arg_CC_Result__'Unchecked_Access);
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CORBA.Repository_Root.ArrayDef.Impl.get_element_type
              (CORBA.Repository_Root.ArrayDef.Impl.Object'Class
                 (Self.all)'Access);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_Uget_element_type;

      procedure Invoke_Uget_element_type_def;

      ----------------------------------
      -- Invoke_Uget_element_type_def --
      ----------------------------------

      procedure Invoke_Uget_element_type_def is
         Result_ : CORBA.Repository_Root.IDLType.Ref;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Result_)'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.IDLType.Helper.TC_IDLType,
               Arg_CC_Result__'Unchecked_Access);
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CORBA.Repository_Root.ArrayDef.Impl.get_element_type_def
              (CORBA.Repository_Root.ArrayDef.Impl.Object'Class
                 (Self.all)'Access);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_Uget_element_type_def;

      procedure Invoke_Uset_element_type_def;

      ----------------------------------
      -- Invoke_Uset_element_type_def --
      ----------------------------------

      procedure Invoke_Uset_element_type_def is
         Argument_To_ : CORBA.Repository_Root.IDLType.Ref;
         pragma Warnings (Off, Argument_To_);
         pragma Suppress (Validity_Check, Argument_To_);
         Arg_CC_To_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Argument_To_)'Unrestricted_Access);
         Arg_Any_To_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.IDLType.Helper.TC_IDLType,
               Arg_CC_To_'Unchecked_Access);
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            set_element_type_def_Arg_Name_To_,
            Arg_Any_To_,
            CORBA.ARG_IN);
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         CORBA.Repository_Root.ArrayDef.Impl.set_element_type_def
           (CORBA.Repository_Root.ArrayDef.Impl.Object'Class
              (Self.all)'Access,
            Argument_To_);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_Uset_element_type_def;

      procedure Invoke_Uget_type;

      ----------------------
      -- Invoke_Uget_type --
      ----------------------

      procedure Invoke_Uget_type is
         Result_ : CORBA.TypeCode.Object;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (Result_'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.TC_TypeCode,
               Arg_CC_Result__'Unchecked_Access);
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CORBA.Repository_Root.ArrayDef.Impl.get_type
              (CORBA.Repository_Root.ArrayDef.Impl.Object'Class
                 (Self.all)'Access);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_Uget_type;

      procedure Invoke_Uget_def_kind;

      --------------------------
      -- Invoke_Uget_def_kind --
      --------------------------

      procedure Invoke_Uget_def_kind is
         Result_ : CORBA.Repository_Root.DefinitionKind;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Repository_Root.Helper.Internals.Wrap
              (Result_'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.Helper.TC_DefinitionKind,
               Arg_CC_Result__'Unchecked_Access);
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CORBA.Repository_Root.ArrayDef.Impl.get_def_kind
              (CORBA.Repository_Root.ArrayDef.Impl.Object'Class
                 (Self.all)'Access);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_Uget_def_kind;

      procedure Invoke_destroy;

      --------------------
      -- Invoke_destroy --
      --------------------

      procedure Invoke_destroy is
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         CORBA.Repository_Root.ArrayDef.Impl.destroy
           (CORBA.Repository_Root.ArrayDef.Impl.Object'Class
              (Self.all)'Access);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_destroy;

      procedure Invoke_Uis_a;

      ------------------
      -- Invoke_Uis_a --
      ------------------

      procedure Invoke_Uis_a is
         Type_Id_ : CORBA.String;
         Arg_Name_Type_Id_ : constant CORBA.Identifier :=
           CORBA.To_CORBA_String
              ("Type_Id_");
         Argument_Type_Id_ : constant CORBA.Any :=
           CORBA.To_Any
              (Type_Id_);
         Result_ : CORBA.Boolean;
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            Arg_Name_Type_Id_,
            Argument_Type_Id_,
            CORBA.ARG_IN);
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         Type_Id_ :=
           CORBA.From_Any
              (Argument_Type_Id_);
         Result_ :=
           Is_A
              (CORBA.To_Standard_String
                 (Type_Id_));
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (Result_));
      end Invoke_Uis_a;

      procedure Invoke_Uinterface;

      -----------------------
      -- Invoke_Uinterface --
      -----------------------

      procedure Invoke_Uinterface is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.Object.Helper.To_Any
              (CORBA.Object.Ref
                 (PolyORB.CORBA_P.IR_Hooks.Get_Interface_Definition
                    (CORBA.To_CORBA_String
                       (Repository_Id)))));
      end Invoke_Uinterface;

      procedure Invoke_Udomain_managers;

      -----------------------------
      -- Invoke_Udomain_managers --
      -----------------------------

      procedure Invoke_Udomain_managers is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            PolyORB.CORBA_P.Domain_Management.Get_Domain_Managers
              (Self));
      end Invoke_Udomain_managers;

      procedure Invoke_Unon_existent;

      --------------------------
      -- Invoke_Unon_existent --
      --------------------------

      procedure Invoke_Unon_existent is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (CORBA.Boolean'
                 (False)));
      end Invoke_Unon_existent;

      procedure Dispatch;

      --------------
      -- Dispatch --
      --------------

      procedure Dispatch is
      begin
         case Index_ is
            when 0 =>
               Invoke_Uget_length;
            when 1 =>
               Invoke_Uset_length;
            when 2 =>
               Invoke_Uget_element_type;
            when 3 =>
               Invoke_Uget_element_type_def;
            when 4 =>
               Invoke_Uset_element_type_def;
            when 5 =>
               Invoke_Uget_type;
            when 6 =>
               Invoke_Uget_def_kind;
            when 7 =>
               Invoke_destroy;
            when 9 =>
               Invoke_Uinterface;
            when 10 =>
               Invoke_Udomain_managers;
            when 11
               | 12 =>
               Invoke_Unon_existent;
            when 8 =>
               Invoke_Uis_a;
            pragma Warnings (Off);
            when others =>
               raise Program_Error;
            pragma Warnings (On);

         end case;
      end Dispatch;

   begin
      CORBA.ORB.Create_List
        (0,
         Argument_List_);
      Index_ :=
        CORBA_Repository_Root_ArrayDef_Hash.Hash
           (Operation_);
      Invoke_Name_Access :=
        Invoke_Db
           (Index_);
      begin
         if (Operation_
            = Invoke_Name_Access.all)
         then
            Dispatch;
         else
            CORBA.Raise_Bad_Operation
              (CORBA.Default_Sys_Member);
         end if;
      exception
         when E : others =>
            CORBA.ServerRequest.Set_Exception
              (Request,
               PolyORB.CORBA_P.Exceptions.System_Exception_To_Any
                 (E));
            PolyORB.Qos.Exception_Informations.Set_Exception_Information
              (Request.all,
               E);
      end;
   end Invoke;

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean;

   ------------------
   -- Servant_Is_A --
   ------------------

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean
   is
   begin
      return (Obj.all
         in CORBA.Repository_Root.ArrayDef.Impl.Object'Class);
   end Servant_Is_A;

   -----------------------------
   -- Deferred_Initialization --
   -----------------------------

   procedure Deferred_Initialization is
   begin
      PortableServer.Internals.Register_Skeleton
        (CORBA.Repository_Root.ArrayDef.Repository_Id,
         Servant_Is_A'Access,
         Is_A'Access,
         Invoke'Access);
      Register_Procedure
        ("_get_length");
      Register_Procedure
        ("_set_length");
      Register_Procedure
        ("_get_element_type");
      Register_Procedure
        ("_get_element_type_def");
      Register_Procedure
        ("_set_element_type_def");
      Register_Procedure
        ("_get_type");
      Register_Procedure
        ("_get_def_kind");
      Register_Procedure
        ("destroy");
      Register_Procedure
        ("_is_a");
      Register_Procedure
        ("_interface");
      Register_Procedure
        ("_domain_managers");
      Register_Procedure
        ("_non_existent");
      Register_Procedure
        ("_not_existent");
   end Deferred_Initialization;

begin
   declare
      use PolyORB.Utils.Strings;
      use PolyORB.Utils.Strings.Lists;
   begin
      PolyORB.Initialization.Register_Module
        (PolyORB.Initialization.Module_Info'
           (Name => +"CORBA.Repository_Root.ArrayDef.Skel",
            Conflicts => PolyORB.Utils.Strings.Lists.Empty,
            Depends => PolyORB.Utils.Strings.Lists.Empty
               & "CORBA.Repository_Root.IDLType.Skel?",
            Provides => PolyORB.Utils.Strings.Lists.Empty,
            Implicit => False,
            Init => Deferred_Initialization'Access,
            Shutdown => null));
   end;
end CORBA.Repository_Root.ArrayDef.Skel;
