pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-bDKkI6/polyorb-2.11~20140418/idls/CORBA_IDL/orb.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with CORBA;
pragma Elaborate_All (CORBA);
with CORBA.Repository_Root.InterfaceAttrExtension.Impl;
with CORBA.Repository_Root.InterfaceAttrExtension.Helper;
with PolyORB.Any;
with CORBA.ServerRequest;
with CORBA.NVList;
with CORBA.Helper;
with CORBA.Repository_Root.Helper;
with CORBA.Repository_Root.IDLType;
with CORBA.Object.Helper;
with CORBA.Object;
with CORBA.Repository_Root.IDLType.Helper;
with CORBA.Repository_Root;
with CORBA.Repository_Root.ExtAttributeDef;
with CORBA.Repository_Root.ExtAttributeDef.Helper;
with PolyORB.CORBA_P.IR_Hooks;
with PolyORB.CORBA_P.Domain_Management;
with CORBA_Repository_Root_InterfaceAttrExtension_Hash;
with PolyORB.Std;
with PortableServer;
with CORBA.ORB;
with PolyORB.CORBA_P.Exceptions;
with PolyORB.Qos.Exception_Informations;
with PolyORB.Utils.Strings;
with PolyORB.Utils.Strings.Lists;
with PolyORB.Initialization;

package body CORBA.Repository_Root.InterfaceAttrExtension.Skel is

   create_ext_attribute_Arg_Name_id_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("id");

   create_ext_attribute_Arg_Name_name_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("name");

   create_ext_attribute_Arg_Name_version_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("version");

   create_ext_attribute_Arg_Name_IDL_type_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("IDL_type");

   create_ext_attribute_Arg_Name_mode_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("mode");

   create_ext_attribute_Arg_Name_get_exceptions_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("get_exceptions");

   create_ext_attribute_Arg_Name_set_exceptions_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("set_exceptions");

   N_Operations : constant PolyORB.Std.Natural :=
     7;

   type String_Ptr is
     access PolyORB.Std.String;

   Invoke_Db : array (0 .. (N_Operations
      - 1)) of String_Ptr :=
     (others => null);

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String);

   ------------------------
   -- Register_Procedure --
   ------------------------

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String)
   is
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;
   begin
      Index_ :=
        CORBA_Repository_Root_InterfaceAttrExtension_Hash.Hash
           (Operation_Name);
      if (Invoke_Db
        (Index_)
         /= null)
      then
         raise Program_Error;
      end if;
      Invoke_Name_Access :=
        new PolyORB.Std.String'
           (Operation_Name);
      Invoke_Db
        (Index_) :=
        Invoke_Name_Access;
   end Register_Procedure;

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr);

   ------------
   -- Invoke --
   ------------

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr)
   is
      Operation_ : constant PolyORB.Std.String :=
        CORBA.To_Standard_String
           (CORBA.ServerRequest.Operation
              (Request.all));
      Argument_List_ : CORBA.NVList.Ref;
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;

      procedure Invoke_describe_ext_interface;

      -----------------------------------
      -- Invoke_describe_ext_interface --
      -----------------------------------

      procedure Invoke_describe_ext_interface is
         Result_ : CORBA.Repository_Root.InterfaceAttrExtension.ExtFullInterfaceDescription;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Repository_Root.InterfaceAttrExtension.Helper.Internals.Wrap
              (Result_'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.InterfaceAttrExtension.Helper.TC_ExtFullInterfaceDescription,
               Arg_CC_Result__'Unchecked_Access);
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CORBA.Repository_Root.InterfaceAttrExtension.Impl.describe_ext_interface
              (CORBA.Repository_Root.InterfaceAttrExtension.Impl.Object'Class
                 (Self.all)'Access);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_describe_ext_interface;

      procedure Invoke_create_ext_attribute;

      ---------------------------------
      -- Invoke_create_ext_attribute --
      ---------------------------------

      procedure Invoke_create_ext_attribute is
         Argument_id_ : CORBA.RepositoryId;
         pragma Warnings (Off, Argument_id_);
         pragma Suppress (Validity_Check, Argument_id_);
         Arg_CC_id_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (CORBA.String
                 (Argument_id_)'Unrestricted_Access);
         Arg_Any_id_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Helper.TC_RepositoryId,
               Arg_CC_id_'Unchecked_Access);
         Argument_name_ : CORBA.Identifier;
         pragma Warnings (Off, Argument_name_);
         pragma Suppress (Validity_Check, Argument_name_);
         Arg_CC_name_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (CORBA.String
                 (Argument_name_)'Unrestricted_Access);
         Arg_Any_name_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Helper.TC_Identifier,
               Arg_CC_name_'Unchecked_Access);
         Argument_version_ : CORBA.Repository_Root.VersionSpec;
         pragma Warnings (Off, Argument_version_);
         pragma Suppress (Validity_Check, Argument_version_);
         Arg_CC_version_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (CORBA.String
                 (Argument_version_)'Unrestricted_Access);
         Arg_Any_version_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.Helper.TC_VersionSpec,
               Arg_CC_version_'Unchecked_Access);
         Argument_IDL_type_ : CORBA.Repository_Root.IDLType.Ref;
         pragma Warnings (Off, Argument_IDL_type_);
         pragma Suppress (Validity_Check, Argument_IDL_type_);
         Arg_CC_IDL_type_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Argument_IDL_type_)'Unrestricted_Access);
         Arg_Any_IDL_type_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.IDLType.Helper.TC_IDLType,
               Arg_CC_IDL_type_'Unchecked_Access);
         Argument_mode_ : CORBA.Repository_Root.AttributeMode;
         pragma Warnings (Off, Argument_mode_);
         pragma Suppress (Validity_Check, Argument_mode_);
         Arg_CC_mode_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Repository_Root.Helper.Internals.Wrap
              (Argument_mode_'Unrestricted_Access);
         Arg_Any_mode_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.Helper.TC_AttributeMode,
               Arg_CC_mode_'Unchecked_Access);
         Argument_get_exceptions_ : CORBA.Repository_Root.ExceptionDefSeq;
         pragma Warnings (Off, Argument_get_exceptions_);
         pragma Suppress (Validity_Check, Argument_get_exceptions_);
         Arg_CC_get_exceptions_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Repository_Root.Helper.Internals.Wrap
              (CORBA.Repository_Root.IDL_SEQUENCE_CORBA_ExceptionDef_Forward.Sequence
                 (Argument_get_exceptions_)'Unrestricted_Access);
         Arg_Any_get_exceptions_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.Helper.TC_ExceptionDefSeq,
               Arg_CC_get_exceptions_'Unchecked_Access);
         Argument_set_exceptions_ : CORBA.Repository_Root.ExceptionDefSeq;
         pragma Warnings (Off, Argument_set_exceptions_);
         pragma Suppress (Validity_Check, Argument_set_exceptions_);
         Arg_CC_set_exceptions_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Repository_Root.Helper.Internals.Wrap
              (CORBA.Repository_Root.IDL_SEQUENCE_CORBA_ExceptionDef_Forward.Sequence
                 (Argument_set_exceptions_)'Unrestricted_Access);
         Arg_Any_set_exceptions_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.Helper.TC_ExceptionDefSeq,
               Arg_CC_set_exceptions_'Unchecked_Access);
         Result_ : CORBA.Repository_Root.ExtAttributeDef.Ref;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Result_)'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Repository_Root.ExtAttributeDef.Helper.TC_ExtAttributeDef,
               Arg_CC_Result__'Unchecked_Access);
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            create_ext_attribute_Arg_Name_id_,
            Arg_Any_id_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            create_ext_attribute_Arg_Name_name_,
            Arg_Any_name_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            create_ext_attribute_Arg_Name_version_,
            Arg_Any_version_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            create_ext_attribute_Arg_Name_IDL_type_,
            Arg_Any_IDL_type_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            create_ext_attribute_Arg_Name_mode_,
            Arg_Any_mode_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            create_ext_attribute_Arg_Name_get_exceptions_,
            Arg_Any_get_exceptions_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            create_ext_attribute_Arg_Name_set_exceptions_,
            Arg_Any_set_exceptions_,
            CORBA.ARG_IN);
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CORBA.Repository_Root.InterfaceAttrExtension.Impl.create_ext_attribute
              (CORBA.Repository_Root.InterfaceAttrExtension.Impl.Object'Class
                 (Self.all)'Access,
               Argument_id_,
               Argument_name_,
               Argument_version_,
               Argument_IDL_type_,
               Argument_mode_,
               Argument_get_exceptions_,
               Argument_set_exceptions_);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_create_ext_attribute;

      procedure Invoke_Uis_a;

      ------------------
      -- Invoke_Uis_a --
      ------------------

      procedure Invoke_Uis_a is
         Type_Id_ : CORBA.String;
         Arg_Name_Type_Id_ : constant CORBA.Identifier :=
           CORBA.To_CORBA_String
              ("Type_Id_");
         Argument_Type_Id_ : constant CORBA.Any :=
           CORBA.To_Any
              (Type_Id_);
         Result_ : CORBA.Boolean;
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            Arg_Name_Type_Id_,
            Argument_Type_Id_,
            CORBA.ARG_IN);
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         Type_Id_ :=
           CORBA.From_Any
              (Argument_Type_Id_);
         Result_ :=
           Is_A
              (CORBA.To_Standard_String
                 (Type_Id_));
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (Result_));
      end Invoke_Uis_a;

      procedure Invoke_Uinterface;

      -----------------------
      -- Invoke_Uinterface --
      -----------------------

      procedure Invoke_Uinterface is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.Object.Helper.To_Any
              (CORBA.Object.Ref
                 (PolyORB.CORBA_P.IR_Hooks.Get_Interface_Definition
                    (CORBA.To_CORBA_String
                       (Repository_Id)))));
      end Invoke_Uinterface;

      procedure Invoke_Udomain_managers;

      -----------------------------
      -- Invoke_Udomain_managers --
      -----------------------------

      procedure Invoke_Udomain_managers is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            PolyORB.CORBA_P.Domain_Management.Get_Domain_Managers
              (Self));
      end Invoke_Udomain_managers;

      procedure Invoke_Unon_existent;

      --------------------------
      -- Invoke_Unon_existent --
      --------------------------

      procedure Invoke_Unon_existent is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (CORBA.Boolean'
                 (False)));
      end Invoke_Unon_existent;

      procedure Dispatch;

      --------------
      -- Dispatch --
      --------------

      procedure Dispatch is
      begin
         case Index_ is
            when 0 =>
               Invoke_describe_ext_interface;
            when 1 =>
               Invoke_create_ext_attribute;
            when 3 =>
               Invoke_Uinterface;
            when 4 =>
               Invoke_Udomain_managers;
            when 5
               | 6 =>
               Invoke_Unon_existent;
            when 2 =>
               Invoke_Uis_a;
            pragma Warnings (Off);
            when others =>
               raise Program_Error;
            pragma Warnings (On);

         end case;
      end Dispatch;

   begin
      CORBA.ORB.Create_List
        (0,
         Argument_List_);
      Index_ :=
        CORBA_Repository_Root_InterfaceAttrExtension_Hash.Hash
           (Operation_);
      Invoke_Name_Access :=
        Invoke_Db
           (Index_);
      begin
         if (Operation_
            = Invoke_Name_Access.all)
         then
            Dispatch;
         else
            CORBA.Raise_Bad_Operation
              (CORBA.Default_Sys_Member);
         end if;
      exception
         when E : others =>
            CORBA.ServerRequest.Set_Exception
              (Request,
               PolyORB.CORBA_P.Exceptions.System_Exception_To_Any
                 (E));
            PolyORB.Qos.Exception_Informations.Set_Exception_Information
              (Request.all,
               E);
      end;
   end Invoke;

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean;

   ------------------
   -- Servant_Is_A --
   ------------------

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean
   is
   begin
      return (Obj.all
         in CORBA.Repository_Root.InterfaceAttrExtension.Impl.Object'Class);
   end Servant_Is_A;

   -----------------------------
   -- Deferred_Initialization --
   -----------------------------

   procedure Deferred_Initialization is
   begin
      PortableServer.Internals.Register_Skeleton
        (CORBA.Repository_Root.InterfaceAttrExtension.Repository_Id,
         Servant_Is_A'Access,
         Is_A'Access,
         Invoke'Access);
      Register_Procedure
        ("describe_ext_interface");
      Register_Procedure
        ("create_ext_attribute");
      Register_Procedure
        ("_is_a");
      Register_Procedure
        ("_interface");
      Register_Procedure
        ("_domain_managers");
      Register_Procedure
        ("_non_existent");
      Register_Procedure
        ("_not_existent");
   end Deferred_Initialization;

begin
   declare
      use PolyORB.Utils.Strings;
      use PolyORB.Utils.Strings.Lists;
   begin
      PolyORB.Initialization.Register_Module
        (PolyORB.Initialization.Module_Info'
           (Name => +"CORBA.Repository_Root.InterfaceAttrExtension.Skel",
            Conflicts => PolyORB.Utils.Strings.Lists.Empty,
            Depends => PolyORB.Utils.Strings.Lists.Empty,
            Provides => PolyORB.Utils.Strings.Lists.Empty,
            Implicit => False,
            Init => Deferred_Initialization'Access,
            Shutdown => null));
   end;
end CORBA.Repository_Root.InterfaceAttrExtension.Skel;
