pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-bDKkI6/polyorb-2.11~20140418/idls/cos/notification/CosNotifyChannelAdmin.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with PolyORB.Any.NVList;
with CORBA.Object.Helper;
with PolyORB.Any;
with PolyORB.Types;
with CosNotification.Helper;
with CosNotifyChannelAdmin.Helper;
with PolyORB.Requests;
with CORBA.ExceptionList;
with CosNotifyChannelAdmin.EventChannel.Helper;
with PolyORB.CORBA_P.Interceptors_Hooks;
with PolyORB.CORBA_P.Exceptions;

package body CosNotifyChannelAdmin.EventChannelFactory is

   create_channel_Arg_Name_initial_qos_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("initial_qos");

   create_channel_Arg_Name_initial_admin_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("initial_admin");

   create_channel_Arg_Name_id_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("id");

   create_channel_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   -----------------------------
   -- create_channel_Result_ --
   -----------------------------

   function create_channel_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (create_channel_Result_);
   begin
      return (Name => create_channel_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyChannelAdmin.EventChannel.Helper.TC_EventChannel),
      Arg_Modes => 0);
   end create_channel_Result_;

   --------------------
   -- create_channel --
   --------------------

   procedure create_channel
     (Self : Ref;
      initial_qos : CosNotification.QoSProperties;
      initial_admin : CosNotification.AdminProperties;
      id : out CosNotifyChannelAdmin.ChannelID;
      Returns : out CosNotifyChannelAdmin.EventChannel.Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyChannelAdmin.EventChannel.Ref
        renames Returns;
      pragma Warnings (Off, Returns);
      pragma Suppress (Validity_Check, Returns);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Object.Helper.Wrap
           (CORBA.Object.Ref
              (Result_)'Unrestricted_Access);
      Arg_CC_initial_qos_ : aliased PolyORB.Any.Content'Class :=
        CosNotification.Helper.Internals.Wrap
           (CosNotification.IDL_SEQUENCE_CosNotification_Property.Sequence
              (initial_qos)'Unrestricted_Access);
      Arg_Any_initial_qos_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotification.Helper.TC_QoSProperties,
            Arg_CC_initial_qos_'Unchecked_Access);
      Arg_CC_initial_admin_ : aliased PolyORB.Any.Content'Class :=
        CosNotification.Helper.Internals.Wrap
           (CosNotification.IDL_SEQUENCE_CosNotification_Property.Sequence
              (initial_admin)'Unrestricted_Access);
      Arg_Any_initial_admin_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotification.Helper.TC_AdminProperties,
            Arg_CC_initial_admin_'Unchecked_Access);
      Arg_CC_id_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (CORBA.Long
              (id)'Unrestricted_Access);
      Arg_Any_id_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotifyChannelAdmin.Helper.TC_ChannelID,
            Arg_CC_id_'Unchecked_Access);
      pragma Warnings (Off, id);
      pragma Suppress (Validity_Check, id);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        create_channel_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         create_channel_Arg_Name_initial_qos_,
         PolyORB.Any.Any
           (Arg_Any_initial_qos_),
         PolyORB.Any.ARG_IN);
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         create_channel_Arg_Name_initial_admin_,
         PolyORB.Any.Any
           (Arg_Any_initial_admin_),
         PolyORB.Any.ARG_IN);
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         create_channel_Arg_Name_id_,
         PolyORB.Any.Any
           (Arg_Any_id_),
         PolyORB.Any.ARG_OUT);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotification.Helper.TC_UnsupportedQoS);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotification.Helper.TC_UnsupportedAdmin);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "create_channel",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end create_channel;

   get_all_channels_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   -------------------------------
   -- get_all_channels_Result_ --
   -------------------------------

   function get_all_channels_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (get_all_channels_Result_);
   begin
      return (Name => get_all_channels_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyChannelAdmin.Helper.TC_ChannelIDSeq),
      Arg_Modes => 0);
   end get_all_channels_Result_;

   ----------------------
   -- get_all_channels --
   ----------------------

   function get_all_channels
     (Self : Ref)
     return CosNotifyChannelAdmin.ChannelIDSeq
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyChannelAdmin.ChannelIDSeq;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CosNotifyChannelAdmin.Helper.Internals.Wrap
           (CosNotifyChannelAdmin.IDL_SEQUENCE_CosNotifyChannelAdmin_ChannelID.Sequence
              (Result_)'Unrestricted_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        get_all_channels_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "get_all_channels",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end get_all_channels;

   get_event_channel_Arg_Name_id_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("id");

   get_event_channel_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   --------------------------------
   -- get_event_channel_Result_ --
   --------------------------------

   function get_event_channel_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (get_event_channel_Result_);
   begin
      return (Name => get_event_channel_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyChannelAdmin.EventChannel.Helper.TC_EventChannel),
      Arg_Modes => 0);
   end get_event_channel_Result_;

   -----------------------
   -- get_event_channel --
   -----------------------

   function get_event_channel
     (Self : Ref;
      id : CosNotifyChannelAdmin.ChannelID)
     return CosNotifyChannelAdmin.EventChannel.Ref
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyChannelAdmin.EventChannel.Ref;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Object.Helper.Wrap
           (CORBA.Object.Ref
              (Result_)'Unrestricted_Access);
      Arg_CC_id_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (CORBA.Long
              (id)'Unrestricted_Access);
      Arg_Any_id_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotifyChannelAdmin.Helper.TC_ChannelID,
            Arg_CC_id_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        get_event_channel_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         get_event_channel_Arg_Name_id_,
         PolyORB.Any.Any
           (Arg_Any_id_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyChannelAdmin.Helper.TC_ChannelNotFound);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "get_event_channel",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end get_event_channel;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Self : Ref;
      Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return (False
         or else (Is_A
           (Logical_Type_Id)
            or else CORBA.Object.Is_A
              (CORBA.Object.Ref
                 (Self),
               Logical_Type_Id)));
   end Is_A;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return ((CORBA.Is_Equivalent
        (Logical_Type_Id,
         CosNotifyChannelAdmin.EventChannelFactory.Repository_Id)
         or else CORBA.Is_Equivalent
           (Logical_Type_Id,
            "IDL:omg.org/CORBA/Object:1.0"))
         or else False);
   end Is_A;

end CosNotifyChannelAdmin.EventChannelFactory;
