pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-bDKkI6/polyorb-2.11~20140418/idls/cos/time/CosTime.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with CosTime.TimeService.Impl;
with CosTime.UTO;
with CORBA.Object.Helper;
with CORBA.Object;
with PolyORB.Any;
with CORBA;
pragma Elaborate_All (CORBA);
with CosTime.UTO.Helper;
with CORBA.ServerRequest;
with CosTime.Helper;
with CORBA.NVList;
with TimeBase;
with TimeBase.Helper;
with CosTime.TIO;
with CosTime.TIO.Helper;
with PolyORB.CORBA_P.IR_Hooks;
with PolyORB.CORBA_P.Domain_Management;
with CosTime_TimeService_Hash;
with PolyORB.Std;
with PortableServer;
with CORBA.ORB;
with PolyORB.CORBA_P.Exceptions;
with PolyORB.Qos.Exception_Informations;
with PolyORB.Utils.Strings;
with PolyORB.Utils.Strings.Lists;
with PolyORB.Initialization;

package body CosTime.TimeService.Skel is

   new_universal_time_Arg_Name_time_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("time");

   new_universal_time_Arg_Name_inaccuracy_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("inaccuracy");

   new_universal_time_Arg_Name_tdf_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("tdf");

   uto_from_utc_Arg_Name_utc_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("utc");

   new_interval_Arg_Name_lower_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("lower");

   new_interval_Arg_Name_upper_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("upper");

   N_Operations : constant PolyORB.Std.Natural :=
     10;

   type String_Ptr is
     access PolyORB.Std.String;

   Invoke_Db : array (0 .. (N_Operations
      - 1)) of String_Ptr :=
     (others => null);

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String);

   ------------------------
   -- Register_Procedure --
   ------------------------

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String)
   is
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;
   begin
      Index_ :=
        CosTime_TimeService_Hash.Hash
           (Operation_Name);
      if (Invoke_Db
        (Index_)
         /= null)
      then
         raise Program_Error;
      end if;
      Invoke_Name_Access :=
        new PolyORB.Std.String'
           (Operation_Name);
      Invoke_Db
        (Index_) :=
        Invoke_Name_Access;
   end Register_Procedure;

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr);

   ------------
   -- Invoke --
   ------------

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr)
   is
      Operation_ : constant PolyORB.Std.String :=
        CORBA.To_Standard_String
           (CORBA.ServerRequest.Operation
              (Request.all));
      Argument_List_ : CORBA.NVList.Ref;
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;

      procedure Invoke_universal_time;

      ---------------------------
      -- Invoke_universal_time --
      ---------------------------

      procedure Invoke_universal_time is
         Result_ : CosTime.UTO.Ref;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Result_)'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CosTime.UTO.Helper.TC_UTO,
               Arg_CC_Result__'Unchecked_Access);
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         begin
            --  Call Implementation
            Result_ :=
              CosTime.TimeService.Impl.universal_time
                 (CosTime.TimeService.Impl.Object'Class
                    (Self.all)'Access);
         exception
            when E : CosTime.TimeUnavailable =>
               declare
                  Members : CosTime.TimeUnavailable_Members;
               begin
                  CosTime.Get_Members
                    (E,
                     Members);
                  CORBA.ServerRequest.Set_Exception
                    (Request,
                     CosTime.Helper.To_Any
                       (Members));
                  return;
               end;
         end;
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_universal_time;

      procedure Invoke_secure_universal_time;

      ----------------------------------
      -- Invoke_secure_universal_time --
      ----------------------------------

      procedure Invoke_secure_universal_time is
         Result_ : CosTime.UTO.Ref;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Result_)'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CosTime.UTO.Helper.TC_UTO,
               Arg_CC_Result__'Unchecked_Access);
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         begin
            --  Call Implementation
            Result_ :=
              CosTime.TimeService.Impl.secure_universal_time
                 (CosTime.TimeService.Impl.Object'Class
                    (Self.all)'Access);
         exception
            when E : CosTime.TimeUnavailable =>
               declare
                  Members : CosTime.TimeUnavailable_Members;
               begin
                  CosTime.Get_Members
                    (E,
                     Members);
                  CORBA.ServerRequest.Set_Exception
                    (Request,
                     CosTime.Helper.To_Any
                       (Members));
                  return;
               end;
         end;
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_secure_universal_time;

      procedure Invoke_new_universal_time;

      -------------------------------
      -- Invoke_new_universal_time --
      -------------------------------

      procedure Invoke_new_universal_time is
         Argument_time_ : TimeBase.TimeT;
         pragma Warnings (Off, Argument_time_);
         pragma Suppress (Validity_Check, Argument_time_);
         Arg_CC_time_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (CORBA.Unsigned_Long_Long
                 (Argument_time_)'Unrestricted_Access);
         Arg_Any_time_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (TimeBase.Helper.TC_TimeT,
               Arg_CC_time_'Unchecked_Access);
         Argument_inaccuracy_ : TimeBase.InaccuracyT;
         pragma Warnings (Off, Argument_inaccuracy_);
         pragma Suppress (Validity_Check, Argument_inaccuracy_);
         Arg_CC_inaccuracy_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (CORBA.Unsigned_Long_Long
                 (Argument_inaccuracy_)'Unrestricted_Access);
         Arg_Any_inaccuracy_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (TimeBase.Helper.TC_InaccuracyT,
               Arg_CC_inaccuracy_'Unchecked_Access);
         Argument_tdf_ : TimeBase.TdfT;
         pragma Warnings (Off, Argument_tdf_);
         pragma Suppress (Validity_Check, Argument_tdf_);
         Arg_CC_tdf_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (CORBA.Short
                 (Argument_tdf_)'Unrestricted_Access);
         Arg_Any_tdf_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (TimeBase.Helper.TC_TdfT,
               Arg_CC_tdf_'Unchecked_Access);
         Result_ : CosTime.UTO.Ref;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Result_)'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CosTime.UTO.Helper.TC_UTO,
               Arg_CC_Result__'Unchecked_Access);
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            new_universal_time_Arg_Name_time_,
            Arg_Any_time_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            new_universal_time_Arg_Name_inaccuracy_,
            Arg_Any_inaccuracy_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            new_universal_time_Arg_Name_tdf_,
            Arg_Any_tdf_,
            CORBA.ARG_IN);
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CosTime.TimeService.Impl.new_universal_time
              (CosTime.TimeService.Impl.Object'Class
                 (Self.all)'Access,
               Argument_time_,
               Argument_inaccuracy_,
               Argument_tdf_);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_new_universal_time;

      procedure Invoke_uto_from_utc;

      -------------------------
      -- Invoke_uto_from_utc --
      -------------------------

      procedure Invoke_uto_from_utc is
         Argument_utc_ : TimeBase.UtcT;
         pragma Warnings (Off, Argument_utc_);
         pragma Suppress (Validity_Check, Argument_utc_);
         Arg_CC_utc_ : aliased PolyORB.Any.Content'Class :=
           TimeBase.Helper.Internals.Wrap
              (Argument_utc_'Unrestricted_Access);
         Arg_Any_utc_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (TimeBase.Helper.TC_UtcT,
               Arg_CC_utc_'Unchecked_Access);
         Result_ : CosTime.UTO.Ref;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Result_)'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CosTime.UTO.Helper.TC_UTO,
               Arg_CC_Result__'Unchecked_Access);
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            uto_from_utc_Arg_Name_utc_,
            Arg_Any_utc_,
            CORBA.ARG_IN);
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CosTime.TimeService.Impl.uto_from_utc
              (CosTime.TimeService.Impl.Object'Class
                 (Self.all)'Access,
               Argument_utc_);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_uto_from_utc;

      procedure Invoke_new_interval;

      -------------------------
      -- Invoke_new_interval --
      -------------------------

      procedure Invoke_new_interval is
         Argument_lower_ : TimeBase.TimeT;
         pragma Warnings (Off, Argument_lower_);
         pragma Suppress (Validity_Check, Argument_lower_);
         Arg_CC_lower_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (CORBA.Unsigned_Long_Long
                 (Argument_lower_)'Unrestricted_Access);
         Arg_Any_lower_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (TimeBase.Helper.TC_TimeT,
               Arg_CC_lower_'Unchecked_Access);
         Argument_upper_ : TimeBase.TimeT;
         pragma Warnings (Off, Argument_upper_);
         pragma Suppress (Validity_Check, Argument_upper_);
         Arg_CC_upper_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (CORBA.Unsigned_Long_Long
                 (Argument_upper_)'Unrestricted_Access);
         Arg_Any_upper_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (TimeBase.Helper.TC_TimeT,
               Arg_CC_upper_'Unchecked_Access);
         Result_ : CosTime.TIO.Ref;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Result_)'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CosTime.TIO.Helper.TC_TIO,
               Arg_CC_Result__'Unchecked_Access);
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            new_interval_Arg_Name_lower_,
            Arg_Any_lower_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            new_interval_Arg_Name_upper_,
            Arg_Any_upper_,
            CORBA.ARG_IN);
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CosTime.TimeService.Impl.new_interval
              (CosTime.TimeService.Impl.Object'Class
                 (Self.all)'Access,
               Argument_lower_,
               Argument_upper_);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_new_interval;

      procedure Invoke_Uis_a;

      ------------------
      -- Invoke_Uis_a --
      ------------------

      procedure Invoke_Uis_a is
         Type_Id_ : CORBA.String;
         Arg_Name_Type_Id_ : constant CORBA.Identifier :=
           CORBA.To_CORBA_String
              ("Type_Id_");
         Argument_Type_Id_ : constant CORBA.Any :=
           CORBA.To_Any
              (Type_Id_);
         Result_ : CORBA.Boolean;
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            Arg_Name_Type_Id_,
            Argument_Type_Id_,
            CORBA.ARG_IN);
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         Type_Id_ :=
           CORBA.From_Any
              (Argument_Type_Id_);
         Result_ :=
           Is_A
              (CORBA.To_Standard_String
                 (Type_Id_));
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (Result_));
      end Invoke_Uis_a;

      procedure Invoke_Uinterface;

      -----------------------
      -- Invoke_Uinterface --
      -----------------------

      procedure Invoke_Uinterface is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.Object.Helper.To_Any
              (CORBA.Object.Ref
                 (PolyORB.CORBA_P.IR_Hooks.Get_Interface_Definition
                    (CORBA.To_CORBA_String
                       (Repository_Id)))));
      end Invoke_Uinterface;

      procedure Invoke_Udomain_managers;

      -----------------------------
      -- Invoke_Udomain_managers --
      -----------------------------

      procedure Invoke_Udomain_managers is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            PolyORB.CORBA_P.Domain_Management.Get_Domain_Managers
              (Self));
      end Invoke_Udomain_managers;

      procedure Invoke_Unon_existent;

      --------------------------
      -- Invoke_Unon_existent --
      --------------------------

      procedure Invoke_Unon_existent is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (CORBA.Boolean'
                 (False)));
      end Invoke_Unon_existent;

      procedure Dispatch;

      --------------
      -- Dispatch --
      --------------

      procedure Dispatch is
      begin
         case Index_ is
            when 0 =>
               Invoke_universal_time;
            when 1 =>
               Invoke_secure_universal_time;
            when 2 =>
               Invoke_new_universal_time;
            when 3 =>
               Invoke_uto_from_utc;
            when 4 =>
               Invoke_new_interval;
            when 6 =>
               Invoke_Uinterface;
            when 7 =>
               Invoke_Udomain_managers;
            when 8
               | 9 =>
               Invoke_Unon_existent;
            when 5 =>
               Invoke_Uis_a;
            pragma Warnings (Off);
            when others =>
               raise Program_Error;
            pragma Warnings (On);

         end case;
      end Dispatch;

   begin
      CORBA.ORB.Create_List
        (0,
         Argument_List_);
      Index_ :=
        CosTime_TimeService_Hash.Hash
           (Operation_);
      Invoke_Name_Access :=
        Invoke_Db
           (Index_);
      begin
         if (Operation_
            = Invoke_Name_Access.all)
         then
            Dispatch;
         else
            CORBA.Raise_Bad_Operation
              (CORBA.Default_Sys_Member);
         end if;
      exception
         when E : others =>
            CORBA.ServerRequest.Set_Exception
              (Request,
               PolyORB.CORBA_P.Exceptions.System_Exception_To_Any
                 (E));
            PolyORB.Qos.Exception_Informations.Set_Exception_Information
              (Request.all,
               E);
      end;
   end Invoke;

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean;

   ------------------
   -- Servant_Is_A --
   ------------------

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean
   is
   begin
      return (Obj.all
         in CosTime.TimeService.Impl.Object'Class);
   end Servant_Is_A;

   -----------------------------
   -- Deferred_Initialization --
   -----------------------------

   procedure Deferred_Initialization is
   begin
      PortableServer.Internals.Register_Skeleton
        (CosTime.TimeService.Repository_Id,
         Servant_Is_A'Access,
         Is_A'Access,
         Invoke'Access);
      Register_Procedure
        ("universal_time");
      Register_Procedure
        ("secure_universal_time");
      Register_Procedure
        ("new_universal_time");
      Register_Procedure
        ("uto_from_utc");
      Register_Procedure
        ("new_interval");
      Register_Procedure
        ("_is_a");
      Register_Procedure
        ("_interface");
      Register_Procedure
        ("_domain_managers");
      Register_Procedure
        ("_non_existent");
      Register_Procedure
        ("_not_existent");
   end Deferred_Initialization;

begin
   declare
      use PolyORB.Utils.Strings;
      use PolyORB.Utils.Strings.Lists;
   begin
      PolyORB.Initialization.Register_Module
        (PolyORB.Initialization.Module_Info'
           (Name => +"CosTime.TimeService.Skel",
            Conflicts => PolyORB.Utils.Strings.Lists.Empty,
            Depends => PolyORB.Utils.Strings.Lists.Empty,
            Provides => PolyORB.Utils.Strings.Lists.Empty,
            Implicit => False,
            Init => Deferred_Initialization'Access,
            Shutdown => null));
   end;
end CosTime.TimeService.Skel;
