with Interfaces; use Interfaces;

package body CORBA_Repository_Root_ValueDef_Hash is

   P : constant array (0 .. 4) of Natural :=
     (2, 4, 8, 10, 14);

   T1 : constant array (0 .. 4) of Unsigned_8 :=
     (30, 25, 69, 17, 5);

   T2 : constant array (0 .. 4) of Unsigned_8 :=
     (100, 77, 52, 62, 41);

   G : constant array (0 .. 110) of Unsigned_8 :=
     (0, 0, 0, 0, 15, 0, 0, 42, 0, 13, 0, 19, 0, 0, 1, 10, 0, 42, 0, 12, 0,
      11, 15, 39, 0, 0, 34, 0, 0, 7, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 0,
      53, 32, 8, 0, 4, 28, 0, 24, 0, 9, 26, 1, 0, 0, 0, 5, 0, 0, 21, 45, 0,
      0, 0, 22, 40, 4, 20, 0, 0, 9, 0, 27, 0, 0, 35, 37, 0, 7, 40, 27, 0, 6,
      34, 0, 50, 0, 0, 42, 2, 0, 0, 0, 12, 7, 0, 0, 0, 9, 50, 51, 51, 5, 0,
      44, 0, 31, 3, 49, 48);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 111;
         F2 := (F2 + Natural (T2 (K)) * J) mod 111;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 55;
   end Hash;

end CORBA_Repository_Root_ValueDef_Hash;
