with Interfaces; use Interfaces;

package body CosNaming_NamingContext_Hash is

   P : constant array (0 .. 2) of Natural :=
     (1, 4, 7);

   T1 : constant array (0 .. 2) of Unsigned_8 :=
     (29, 11, 19);

   T2 : constant array (0 .. 2) of Unsigned_8 :=
     (27, 27, 2);

   G : constant array (0 .. 30) of Unsigned_8 :=
     (0, 0, 0, 9, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 14, 3, 11, 11, 2, 6, 0,
      5, 0, 5, 0, 0, 3, 1, 5, 7);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 31;
         F2 := (F2 + Natural (T2 (K)) * J) mod 31;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 15;
   end Hash;

end CosNaming_NamingContext_Hash;
