pragma Style_Checks ("NM32766");
pragma Wide_Character_Encoding (Brackets);

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-bDKkI6/polyorb-2.11~20140418/idls/cos/notification/CosNotifyChannelAdmin.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with CosNotification;
with CosNotification.QoSAdmin;
with PolyORB.Std;
with CosNotifyFilter;
with CosNotifyFilter.MappingFilter;
with CosNotifyChannelAdmin.ProxySupplier;
with CosNotifyFilter.Filter;
with CosEventChannelAdmin;
with CosEventChannelAdmin.ProxyPushSupplier;
with CosEventChannelAdmin.ProxyPullSupplier;
with CORBA;
pragma Elaborate_All (CORBA);

package CosNotifyChannelAdmin.ConsumerAdmin is

   type Ref is
     new CosNotification.QoSAdmin.Ref with null record;

   Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin:1.0";

   MyID_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/MyID:1.0";

   function get_MyID
     (Self : Ref)
     return CosNotifyChannelAdmin.AdminID;

   MyChannel_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/MyChannel:1.0";

   function get_MyChannel
     (Self : Ref)
     return CosNotifyChannelAdmin.EventChannel_Forward.Ref;

   MyOperator_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/MyOperator:1.0";

   function get_MyOperator
     (Self : Ref)
     return CosNotifyChannelAdmin.InterFilterGroupOperator;

   priority_filter_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/priority_filter:1.0";

   function get_priority_filter
     (Self : Ref)
     return CosNotifyFilter.MappingFilter.Ref;

   procedure set_priority_filter
     (Self : Ref;
      To : CosNotifyFilter.MappingFilter.Ref);

   lifetime_filter_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/lifetime_filter:1.0";

   function get_lifetime_filter
     (Self : Ref)
     return CosNotifyFilter.MappingFilter.Ref;

   procedure set_lifetime_filter
     (Self : Ref;
      To : CosNotifyFilter.MappingFilter.Ref);

   pull_suppliers_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/pull_suppliers:1.0";

   function get_pull_suppliers
     (Self : Ref)
     return CosNotifyChannelAdmin.ProxyIDSeq;

   push_suppliers_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/push_suppliers:1.0";

   function get_push_suppliers
     (Self : Ref)
     return CosNotifyChannelAdmin.ProxyIDSeq;

   function get_proxy_supplier
     (Self : Ref;
      proxy_id : CosNotifyChannelAdmin.ProxyID)
     return CosNotifyChannelAdmin.ProxySupplier.Ref;

   get_proxy_supplier_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/get_proxy_supplier:1.0";

   procedure obtain_notification_pull_supplier
     (Self : Ref;
      ctype : CosNotifyChannelAdmin.ClientType;
      proxy_id : out CosNotifyChannelAdmin.ProxyID;
      Returns : out CosNotifyChannelAdmin.ProxySupplier.Ref);

   obtain_notification_pull_supplier_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/obtain_notification_pull_supplier:1.0";

   procedure obtain_notification_push_supplier
     (Self : Ref;
      ctype : CosNotifyChannelAdmin.ClientType;
      proxy_id : out CosNotifyChannelAdmin.ProxyID;
      Returns : out CosNotifyChannelAdmin.ProxySupplier.Ref);

   obtain_notification_push_supplier_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/obtain_notification_push_supplier:1.0";

   procedure destroy
     (Self : Ref);

   destroy_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/ConsumerAdmin/destroy:1.0";

   --  subscription_change : inherited from CosNotifyComm.NotifySubscribe

   procedure subscription_change
     (Self : Ref;
      added : CosNotification.EventTypeSeq;
      removed : CosNotification.EventTypeSeq);

   --  add_filter : inherited from CosNotifyFilter.FilterAdmin

   function add_filter
     (Self : Ref;
      new_filter : CosNotifyFilter.Filter.Ref)
     return CosNotifyFilter.FilterID;

   --  remove_filter : inherited from CosNotifyFilter.FilterAdmin

   procedure remove_filter
     (Self : Ref;
      filter : CosNotifyFilter.FilterID);

   --  get_filter : inherited from CosNotifyFilter.FilterAdmin

   function get_filter
     (Self : Ref;
      filter : CosNotifyFilter.FilterID)
     return CosNotifyFilter.Filter.Ref;

   --  get_all_filters : inherited from CosNotifyFilter.FilterAdmin

   function get_all_filters
     (Self : Ref)
     return CosNotifyFilter.FilterIDSeq;

   --  remove_all_filters : inherited from CosNotifyFilter.FilterAdmin

   procedure remove_all_filters
     (Self : Ref);

   --  obtain_push_supplier : inherited from 
   --  CosEventChannelAdmin.ConsumerAdmin

   function obtain_push_supplier
     (Self : Ref)
     return CosEventChannelAdmin.ProxyPushSupplier.Ref;

   --  obtain_pull_supplier : inherited from 
   --  CosEventChannelAdmin.ConsumerAdmin

   function obtain_pull_supplier
     (Self : Ref)
     return CosEventChannelAdmin.ProxyPullSupplier.Ref;

   function Is_A
     (Self : Ref;
      Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean;

   package Convert_Forward is
     new CosNotifyChannelAdmin.ConsumerAdmin_Forward.Convert
        (Ref);

private
   function Is_A
     (Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean;

end CosNotifyChannelAdmin.ConsumerAdmin;
