pragma Style_Checks ("NM32766");
pragma Wide_Character_Encoding (Brackets);

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-bDKkI6/polyorb-2.11~20140418/idls/cos/notification/CosNotifyChannelAdmin.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with CosNotification;
with CosNotification.QoSAdmin;
with PolyORB.Std;
with CosNotifyChannelAdmin.ConsumerAdmin;
with CosNotifyChannelAdmin.SupplierAdmin;
with CosNotifyFilter;
with CosNotifyFilter.FilterFactory;
with CosEventChannelAdmin;
with CosEventChannelAdmin.ConsumerAdmin;
with CosEventChannelAdmin.SupplierAdmin;
with CORBA;
pragma Elaborate_All (CORBA);

package CosNotifyChannelAdmin.EventChannel is

   type Ref is
     new CosNotification.QoSAdmin.Ref with null record;

   Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel:1.0";

   MyFactory_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/MyFactory:1.0";

   function get_MyFactory
     (Self : Ref)
     return CosNotifyChannelAdmin.EventChannelFactory_Forward.Ref;

   default_consumer_admin_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/default_consumer_admin:1.0";

   function get_default_consumer_admin
     (Self : Ref)
     return CosNotifyChannelAdmin.ConsumerAdmin.Ref;

   default_supplier_admin_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/default_supplier_admin:1.0";

   function get_default_supplier_admin
     (Self : Ref)
     return CosNotifyChannelAdmin.SupplierAdmin.Ref;

   default_filter_factory_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/default_filter_factory:1.0";

   function get_default_filter_factory
     (Self : Ref)
     return CosNotifyFilter.FilterFactory.Ref;

   procedure new_for_consumers
     (Self : Ref;
      op : CosNotifyChannelAdmin.InterFilterGroupOperator;
      id : out CosNotifyChannelAdmin.AdminID;
      Returns : out CosNotifyChannelAdmin.ConsumerAdmin.Ref);

   new_for_consumers_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/new_for_consumers:1.0";

   procedure new_for_suppliers
     (Self : Ref;
      op : CosNotifyChannelAdmin.InterFilterGroupOperator;
      id : out CosNotifyChannelAdmin.AdminID;
      Returns : out CosNotifyChannelAdmin.SupplierAdmin.Ref);

   new_for_suppliers_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/new_for_suppliers:1.0";

   function get_consumeradmin
     (Self : Ref;
      id : CosNotifyChannelAdmin.AdminID)
     return CosNotifyChannelAdmin.ConsumerAdmin.Ref;

   get_consumeradmin_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/get_consumeradmin:1.0";

   function get_supplieradmin
     (Self : Ref;
      id : CosNotifyChannelAdmin.AdminID)
     return CosNotifyChannelAdmin.SupplierAdmin.Ref;

   get_supplieradmin_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/get_supplieradmin:1.0";

   function get_all_consumeradmins
     (Self : Ref)
     return CosNotifyChannelAdmin.AdminIDSeq;

   get_all_consumeradmins_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/get_all_consumeradmins:1.0";

   function get_all_supplieradmins
     (Self : Ref)
     return CosNotifyChannelAdmin.AdminIDSeq;

   get_all_supplieradmins_Repository_Id : constant PolyORB.Std.String :=
     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel/get_all_supplieradmins:1.0";

   --  get_admin : inherited from CosNotification.AdminPropertiesAdmin

   function get_admin
     (Self : Ref)
     return CosNotification.AdminProperties;

   --  set_admin : inherited from CosNotification.AdminPropertiesAdmin

   procedure set_admin
     (Self : Ref;
      admin : CosNotification.AdminProperties);

   --  for_consumers : inherited from CosEventChannelAdmin.EventChannel

   function for_consumers
     (Self : Ref)
     return CosEventChannelAdmin.ConsumerAdmin.Ref;

   --  for_suppliers : inherited from CosEventChannelAdmin.EventChannel

   function for_suppliers
     (Self : Ref)
     return CosEventChannelAdmin.SupplierAdmin.Ref;

   --  destroy : inherited from CosEventChannelAdmin.EventChannel

   procedure destroy
     (Self : Ref);

   function Is_A
     (Self : Ref;
      Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean;

   package Convert_Forward is
     new CosNotifyChannelAdmin.EventChannel_Forward.Convert
        (Ref);

private
   function Is_A
     (Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean;

end CosNotifyChannelAdmin.EventChannel;
